| Flutter Impeller |

Classes | Public Member Functions | Static Public Member Functions | List of all members
impeller::ContextMTL Class Referencefinal

`#include <context_mtl.h>`

Inheritance diagram for impeller::ContextMTL:

## Public Member Functions
| ~ContextMTL () override
BackendType | GetBackendType () const override
| Get the graphics backend of an Impeller context. More...
id< MTLDevice > | GetMTLDevice () const
std::string | DescribeGpuModel () const override
bool | IsValid () const override
| Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context. More...
std::shared_ptr< Allocator > | GetResourceAllocator () const override
| Returns the allocator used to create textures and buffers on the device. More...
std::shared_ptr< ShaderLibrary > | GetShaderLibrary () const override
| Returns the library of shaders used to specify the programmable stages of a pipeline. More...
std::shared_ptr< SamplerLibrary > | GetSamplerLibrary () const override
| Returns the library of combined image samplers used in shaders. More...
std::shared_ptr< PipelineLibrary > | GetPipelineLibrary () const override
| Returns the library of pipelines used by render or compute commands. More...
std::shared_ptr< CommandBuffer > | CreateCommandBuffer () const override
| Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device. More...
const std::shared_ptr< const Capabilities > & | GetCapabilities () const override
| Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`. More...
void | SetCapabilities (const std::shared_ptr< const Capabilities > &capabilities)
bool | UpdateOffscreenLayerPixelFormat (PixelFormat format) override
void | Shutdown () override
| Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops. More...
id< MTLCommandBuffer > | CreateMTLCommandBuffer (const std::string &label) const
const std::shared_ptr< fml::ConcurrentTaskRunner > | GetWorkerTaskRunner () const
std::shared_ptr< const fml::SyncSwitch > | GetIsGpuDisabledSyncSwitch () const
void | StoreTaskForGPU (const std::function< void()> &task) override
Public Member Functions inherited from impeller::Context
virtual | ~Context ()
| Destroys an Impeller context. More...
virtual void | SetSyncPresentation (bool value)
| Force the Vulkan presentation (submitKHR) to be performed on the raster task runner. More...
Pool< HostBuffer > & | GetHostBufferPool () const
| Accessor for a pool of HostBuffers. More...

## Static Public Member Functions
static std::shared_ptr< ContextMTL > | Create (const std::vector< std::string > &shader_library_paths, std::shared_ptr< const fml::SyncSwitch > is_gpu_disabled_sync_switch)
static std::shared_ptr< ContextMTL > | Create (const std::vector< std::shared_ptr< fml::Mapping >> &shader_libraries_data, std::shared_ptr< const fml::SyncSwitch > is_gpu_disabled_sync_switch, const std::string &label)
static std::shared_ptr< ContextMTL > | Create (id< MTLDevice > device, id< MTLCommandQueue > command_queue, const std::vector< std::shared_ptr< fml::Mapping >> &shader_libraries_data, std::shared_ptr< const fml::SyncSwitch > is_gpu_disabled_sync_switch, const std::string &label)
Static Public Member Functions inherited from impeller::BackendCast< ContextMTL, Context >
static ContextMTL & | Cast (Context &base)
static const ContextMTL & | Cast (const Context &base)
static ContextMTL * | Cast (Context *base)
static const ContextMTL * | Cast (const Context *base)

## Additional Inherited Members
Public Types inherited from impeller::Context
enum | BackendType { BackendType::kMetal, BackendType::kOpenGLES, BackendType::kVulkan }
Public Attributes inherited from impeller::Context
CaptureContext | capture
Static Public Attributes inherited from impeller::Context
static constexpr int32_t | kMaxTasksAwaitingGPU = 10
Protected Member Functions inherited from impeller::Context
| Context ()

## Detailed Description

Definition at line 34 of file context_mtl.h.

## Constructor & Destructor Documentation

## ◆ ~ContextMTL()

impeller::ContextMTL::~ContextMTL | ( |  | ) |
| override

Definition at line 294 of file context_mtl.mm.

294 {
295 is_gpu_disabled_sync_switch_->RemoveObserver(sync_switch_observer_.get());
296 }

## Member Function Documentation

## ◆ Create() [1/3]

std::shared_ptr< ContextMTL > impeller::ContextMTL::Create | ( | const std::vector< std::shared_ptr< fml::Mapping >> & | shader_libraries_data,
|  | std::shared_ptr< const fml::SyncSwitch > | is_gpu_disabled_sync_switch,
|  | const std::string & | label
| ) |  |
| static

Definition at line 255 of file context_mtl.mm.

258 {
259 auto device = CreateMetalDevice();
260 auto command_queue = CreateMetalCommandQueue(device);
261 if (!command_queue) {
262 return nullptr;
263 }
264 auto context = std::shared_ptr<ContextMTL>(
265 new ContextMTL(device, command_queue,
266 MTLShaderLibraryFromFileData(device, shader_libraries_data,
267 library_label),
268 std::move(is_gpu_disabled_sync_switch)));
269 if (!context->IsValid()) {
270 FML_LOG(ERROR) << "Could not create Metal context.";
271 return nullptr;
272 }
273 return context;
274 }

References impeller::CreateMetalCommandQueue(), impeller::CreateMetalDevice(), and impeller::MTLShaderLibraryFromFileData().

## ◆ Create() [2/3]

std::shared_ptr< ContextMTL > impeller::ContextMTL::Create | ( | const std::vector< std::string > & | shader_library_paths,
|  | std::shared_ptr< const fml::SyncSwitch > | is_gpu_disabled_sync_switch
| ) |  |
| static

Definition at line 236 of file context_mtl.mm.

238 {
239 auto device = CreateMetalDevice();
240 auto command_queue = CreateMetalCommandQueue(device);
241 if (!command_queue) {
242 return nullptr;
243 }
244 auto context = std::shared_ptr<ContextMTL>(new ContextMTL(
245 device, command_queue,
246 MTLShaderLibraryFromFilePaths(device, shader_library_paths),
247 std::move(is_gpu_disabled_sync_switch)));
248 if (!context->IsValid()) {
249 FML_LOG(ERROR) << "Could not create Metal context.";
250 return nullptr;
251 }
252 return context;
253 }

References impeller::CreateMetalCommandQueue(), impeller::CreateMetalDevice(), and impeller::MTLShaderLibraryFromFilePaths().

Referenced by impeller::PlaygroundImplMTL::PlaygroundImplMTL().

## ◆ Create() [3/3]

std::shared_ptr< ContextMTL > impeller::ContextMTL::Create | ( | id< MTLDevice > | device,
|  | id< MTLCommandQueue > | command_queue,
|  | const std::vector< std::shared_ptr< fml::Mapping >> & | shader_libraries_data,
|  | std::shared_ptr< const fml::SyncSwitch > | is_gpu_disabled_sync_switch,
|  | const std::string & | label
| ) |  |
| static

Definition at line 276 of file context_mtl.mm.

281 {
282 auto context = std::shared_ptr<ContextMTL>(
283 new ContextMTL(device, command_queue,
284 MTLShaderLibraryFromFileData(device, shader_libraries_data,
285 library_label),
286 std::move(is_gpu_disabled_sync_switch)));
287 if (!context->IsValid()) {
288 FML_LOG(ERROR) << "Could not create Metal context.";
289 return nullptr;
290 }
291 return context;
292 }

References impeller::MTLShaderLibraryFromFileData().

## ◆ CreateCommandBuffer()

std::shared_ptr< CommandBuffer > impeller::ContextMTL::CreateCommandBuffer | ( |  | ) | const
| override virtual

Create a new command buffer. Command buffers can be used to encode graphics, blit, or compute commands to be submitted to the device.

A command buffer can only be used on a single thread. Multi-threaded render, blit, or compute passes must create a new command buffer on each thread.

Returns
  A new command buffer.

Implements impeller::Context.

Definition at line 328 of file context_mtl.mm.

328 {
329 return CreateCommandBufferInQueue(command_queue_);
330 }

## ◆ CreateMTLCommandBuffer()

id< MTLCommandBuffer > impeller::ContextMTL::CreateMTLCommandBuffer | ( | const std::string & | label | ) | const

Definition at line 390 of file context_mtl.mm.

391 {
392 auto buffer = [command_queue_ commandBuffer];
393 if (!label.empty()) {
394 [buffer setLabel:@(label.data())];
395 }
396 return buffer;
397 }

Referenced by impeller::SurfaceMTL::Present().

## ◆ DescribeGpuModel()

std::string impeller::ContextMTL::DescribeGpuModel | ( |  | ) | const
| override virtual

Implements impeller::Context.

Definition at line 303 of file context_mtl.mm.

303 {
304 return std::string([[device_ name] UTF8String]);
305 }

## ◆ GetBackendType()

Context::BackendType impeller::ContextMTL::GetBackendType | ( |  | ) | const
| override virtual

Get the graphics backend of an Impeller context.

            This is useful for cases where a renderer needs to track and
            lookup backend-specific resources, like shaders or uniform
            layout information.

            It's not recommended to use this as a substitute for
            per-backend capability checking. Instead, check for specific
            capabilities via `GetCapabilities()`.

Returns
  The graphics backend of the `Context`.

Implements impeller::Context.

Definition at line 298 of file context_mtl.mm.

298 {
299 return Context::BackendType::kMetal;
300 }

## ◆ GetCapabilities()

const std::shared_ptr< const Capabilities > & impeller::ContextMTL::GetCapabilities | ( |  | ) | const
| override virtual

Get the capabilities of Impeller context. All optionally supported feature of the platform, client-rendering API, and device can be queried using the `Capabilities`.

Returns
  The capabilities. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 375 of file context_mtl.mm.

375 {
376 return device_capabilities_;
377 }

## ◆ GetIsGpuDisabledSyncSwitch()

std::shared_ptr< const fml::SyncSwitch > impeller::ContextMTL::GetIsGpuDisabledSyncSwitch | ( |  | ) | const

Definition at line 348 of file context_mtl.mm.

349 {
350 return is_gpu_disabled_sync_switch_;
351 }

## ◆ GetMTLDevice()

id< MTLDevice > impeller::ContextMTL::GetMTLDevice | ( |  | ) | const

Definition at line 371 of file context_mtl.mm.

371 {
372 return device_;
373 }

Referenced by impeller::PlaygroundImplMTL::PlaygroundImplMTL().

## ◆ GetPipelineLibrary()

std::shared_ptr< PipelineLibrary > impeller::ContextMTL::GetPipelineLibrary | ( |  | ) | const
| override virtual

Returns the library of pipelines used by render or compute commands.

Returns
  The pipeline library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 318 of file context_mtl.mm.

318 {
319 return pipeline_library_;
320 }

## ◆ GetResourceAllocator()

std::shared_ptr< Allocator > impeller::ContextMTL::GetResourceAllocator | ( |  | ) | const
| override virtual

Returns the allocator used to create textures and buffers on the device.

Returns
  The resource allocator. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 367 of file context_mtl.mm.

367 {
368 return resource_allocator_;
369 }

## ◆ GetSamplerLibrary()

std::shared_ptr< SamplerLibrary > impeller::ContextMTL::GetSamplerLibrary | ( |  | ) | const
| override virtual

Returns the library of combined image samplers used in shaders.

Returns
  The sampler library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 323 of file context_mtl.mm.

323 {
324 return sampler_library_;
325 }

## ◆ GetShaderLibrary()

std::shared_ptr< ShaderLibrary > impeller::ContextMTL::GetShaderLibrary | ( |  | ) | const
| override virtual

Returns the library of shaders used to specify the programmable stages of a pipeline.

Returns
  The shader library. Can never be `nullptr` for a valid context.

Implements impeller::Context.

Definition at line 313 of file context_mtl.mm.

313 {
314 return shader_library_;
315 }

## ◆ GetWorkerTaskRunner()

const std::shared_ptr< fml::ConcurrentTaskRunner > impeller::ContextMTL::GetWorkerTaskRunner | ( |  | ) | const

Definition at line 344 of file context_mtl.mm.

344 {
345 return raster_message_loop_->GetTaskRunner();
346 }

## ◆ IsValid()

bool impeller::ContextMTL::IsValid | ( |  | ) | const
| override virtual

Determines if a context is valid. If the caller ever receives an invalid context, they must discard it and construct a new context. There is no recovery mechanism to repair a bad context.

It is convention in Impeller to never return an invalid context from a call that returns an pointer to a context. The call implementation performs validity checks itself and return a null context instead of a pointer to an invalid context.

How a context goes invalid is backend specific. It could happen due to device loss, or any other unrecoverable error.

Returns
  If the context is valid.

Implements impeller::Context.

Definition at line 308 of file context_mtl.mm.

308 {
309 return is_valid_;
310 }

## ◆ SetCapabilities()

void impeller::ContextMTL::SetCapabilities | ( | const std::shared_ptr< const Capabilities > & | capabilities | ) |

Definition at line 379 of file context_mtl.mm.

380 {
381 device_capabilities_ = capabilities;
382 }

## ◆ Shutdown()

void impeller::ContextMTL::Shutdown | ( |  | ) |
| override virtual

Force all pending asynchronous work to finish. This is achieved by deleting all owned concurrent message loops.

Implements impeller::Context.

Definition at line 333 of file context_mtl.mm.

333 {
334 raster_message_loop_.reset();
335 }

## ◆ StoreTaskForGPU()

void impeller::ContextMTL::StoreTaskForGPU | ( | const std::function< void()> & | task | ) |
| override virtual

Stores a task on the `ContextMTL` that is awaiting access for the GPU.

The task will be executed in the event that the GPU access has changed to being available or that the task has been canceled. The task should operate with the `SyncSwitch` to make sure the GPU is accessible.

Threadsafe.

`task` will be executed on the platform thread.

Reimplemented from impeller::Context.

Definition at line 399 of file context_mtl.mm.

399 {
400 tasks_awaiting_gpu_.emplace_back(task);
401 while (tasks_awaiting_gpu_.size() > kMaxTasksAwaitingGPU) {
402 tasks_awaiting_gpu_.front()();
403 tasks_awaiting_gpu_.pop_front();
404 }
405 }

## ◆ UpdateOffscreenLayerPixelFormat()

bool impeller::ContextMTL::UpdateOffscreenLayerPixelFormat | ( | PixelFormat | format | ) |
| override virtual

Reimplemented from impeller::Context.

Definition at line 385 of file context_mtl.mm.

385 {
386 device_capabilities_ = InferMetalCapabilities(device_, format);
387 return true;
388 }

References impeller::InferMetalCapabilities().

The documentation for this class was generated from the following files:

- impeller/renderer/backend/metal/context_mtl.h
- impeller/renderer/backend/metal/context_mtl.mm

impeller::MTLShaderLibraryFromFileData
static NSArray< id< MTLLibrary > > * MTLShaderLibraryFromFileData(id< MTLDevice > device, const std::vector< std::shared_ptr< fml::Mapping >> &libraries_data, const std::string &label)
Definition: context_mtl.mm:179
impeller::CreateMetalCommandQueue
static id< MTLCommandQueue > CreateMetalCommandQueue(id< MTLDevice > device)
Definition: context_mtl.mm:226
impeller::CreateMetalDevice
static id< MTLDevice > CreateMetalDevice()
Definition: context_mtl.mm:222
impeller::InferMetalCapabilities
static std::unique_ptr< Capabilities > InferMetalCapabilities(id< MTLDevice > device, PixelFormat color_format)
Definition: context_mtl.mm:54
impeller::Context::BackendType::kMetal
@ kMetal
impeller::MTLShaderLibraryFromFilePaths
static NSArray< id< MTLLibrary > > * MTLShaderLibraryFromFilePaths(id< MTLDevice > device, const std::vector< std::string > &libraries_paths)
Definition: context_mtl.mm:156
impeller::Context::kMaxTasksAwaitingGPU
static constexpr int32_t kMaxTasksAwaitingGPU
Definition: context.h:61